'use strict';

var _babelCore = require('babel-core');

var _ = require('../');

var _2 = _interopRequireDefault(_);

var _babelPluginTransformEs2015Classes = require('babel-plugin-transform-es2015-classes');

var _babelPluginTransformEs2015Classes2 = _interopRequireDefault(_babelPluginTransformEs2015Classes);

var _babelPluginTransformReactJsx = require('babel-plugin-transform-react-jsx');

var _babelPluginTransformReactJsx2 = _interopRequireDefault(_babelPluginTransformReactJsx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test('simple undeclared variable', function () {
  // counter example
  var opts = {
    babelrc: false,
    plugins: [_2.default]
  };
  var input = 'Promise.resolve(foo).then(console.log);';
  expect(function () {
    return (0, _babelCore.transform)(input, opts);
  }).toThrow(/Reference to undeclared variable "foo"/);
});
test('jsx undeclared variable', function () {
  // counter example
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformReactJsx2.default, _2.default]
  };
  var input = 'const x = <Foo />';
  expect(function () {
    return (0, _babelCore.transform)(input, opts);
  }).toThrow(/Reference to undeclared variable "Foo"/);
});

test('Declared variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_2.default]
  };
  var input = '\n    import Foo from \'./foo\';\n\n    class Bar extends Foo {\n      constructor(props) {\n        super(props);\n      }\n    }\n  ';

  var _transform = (0, _babelCore.transform)(input, opts),
      code = _transform.code;

  expect(code).toMatchSnapshot();
});

test('Declared, transformed variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformEs2015Classes2.default, _2.default]
  };
  var input = '\n    import Foo from \'./foo\';\n\n    class Bar extends Foo {\n      constructor(props) {\n        super(props);\n      }\n    }\n  ';

  var _transform2 = (0, _babelCore.transform)(input, opts),
      code = _transform2.code;

  expect(code).toMatchSnapshot();
});

test('Declared, transformed variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformEs2015Classes2.default, _2.default]
  };
  var input = '\n    import {Component, Children} from \'react\';\n\n    class Provider extends Component {\n      getChildContext() {\n        return {loginClient: this.client};\n      }\n\n      constructor(props, context) {\n        super(props, context);\n        this.client = props.client;\n      }\n\n      render() {\n        return Children.only(this.props.children);\n      }\n    }\n  ';

  var _transform3 = (0, _babelCore.transform)(input, opts),
      code = _transform3.code;

  expect(code).toMatchSnapshot();
});